﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace Prohlizec
{
    public partial class full : Form
    {
        public full()
        {
            InitializeComponent();
            m_all = null;
            m_sel = 0;
        }

        private Array m_all;
        private int m_sel;
        private float m_ratio;
        private Image m_curr;

        private void full_Load(object sender, EventArgs e)
        {
            this.Size = SystemInformation.PrimaryMonitorSize;
        }

        private void escButton_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        public void ShowFullscreen(Array allInDir, preview selected)
        {
            String path = selected.GetPath();
            String dir = System.IO.Path.GetDirectoryName(path);
            String[] files = System.IO.Directory.GetFiles(dir, "*.jp*g");

            // get number of image in folder
            int selNum=0; int i=0;
            foreach (String f in files)
            {
                if (f == path)
                {
                    selNum = i;
                    break;
                }
                i++;
            }


            m_all = allInDir;
            m_sel = selNum;

            LoadImage(selected);
        }

        private void LoadImage(preview pr)
        {
            m_curr = Image.FromFile(pr.GetPath());
            String path = pr.GetPath();
            if (m_curr.Width > m_curr.Height)
                m_ratio = 100.0f / m_curr.Width * pic.Width;
            else
                m_ratio = 100.0f / m_curr.Height * pic.Height;

            pic.Image = m_curr.GetThumbnailImage((int)((float)m_curr.Width * m_ratio / 100), (int)((float)m_curr.Height * m_ratio / 100), null, System.IntPtr.Zero);

            lblZoom.Text = "Zvětšení: " + System.Math.Round(m_ratio, 0) + "%";
            lblName.Text = System.IO.Path.GetFileName(path);
            lblDesc.Text = pr.GetDesc();
            lblDate.Text = pr.GetDate();

            lblInfo.Text = "Obrázek " + (m_sel+1) + " / " + m_all.Length;
        }

        private void Zoom()
        {
            if (m_curr == null) return;
            pic.Image = m_curr.GetThumbnailImage((int)((float)m_curr.Width * m_ratio / 100), (int)((float)m_curr.Height * m_ratio / 100), null, System.IntPtr.Zero);

            lblZoom.Text = "Zvětšení: " + System.Math.Round(m_ratio, 0) + "%";
        }


        private void btnLeft_Click(object sender, EventArgs e)
        {
            if (m_sel == 0) return; // min reached

            m_sel--;
            preview pr = (preview)m_all.GetValue(m_sel);

            // load image
            LoadImage(pr);
        }

        private void btnRight_Click(object sender, EventArgs e)
        {
            if (m_sel == m_all.Length-1) return; // min reached

            m_sel++;
            preview pr = (preview)m_all.GetValue(m_sel);

            // load image
            LoadImage(pr);
        }

        private void btnLeft_KeyDown(object sender, KeyEventArgs e)
        {
           // if (e. == Keys.Left)
             //   MessageBox.Show("test");
        }

        private void btnPlus_Click(object sender, EventArgs e)
        {
            m_ratio += 10;
            Zoom();
        }

        private void btnMinus_Click(object sender, EventArgs e)
        {
            m_ratio -= 10;
            if (m_ratio < 10) m_ratio = 10;
            Zoom();
        }

        private void btn_Click(object sender, EventArgs e)
        {
            Application.Exit();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void button2_Click(object sender, EventArgs e)
        {
            m_curr.RotateFlip(RotateFlipType.Rotate90FlipNone);
            m_curr.RotateFlip(RotateFlipType.Rotate180FlipNone);
            Zoom();
        }

        private void button3_Click(object sender, EventArgs e)
        {
            m_curr.RotateFlip(RotateFlipType.Rotate90FlipNone);
            Zoom();
        }

        private void button4_Click(object sender, EventArgs e)
        {
            m_curr.RotateFlip(RotateFlipType.RotateNoneFlipX);
            Zoom();
        }

        private void button5_Click(object sender, EventArgs e)
        {
            m_curr.RotateFlip(RotateFlipType.RotateNoneFlipY);
            Zoom();
        }


    }
}
